%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                                    PSG Type    PSG Object                    Location in Problem Statement                                Class
%matrix_scenarios_benchmark                bench       matrix_scenarios              meanabs_err(matrix_scenarios)                                double
%matrix_scenarios_data                     data        matrix_scenarios              meanabs_err(matrix_scenarios)                                double
%matrix_scenarios_vars                     vars        matrix_scenarios              meanabs_err(matrix_scenarios)                                cell
%matrix_constraint_budget_data             data        matrix_constraint_budget      polynom_abs(matrix_constraint_budget)                        double
%matrix_constraint_budget_vars             vars        matrix_constraint_budget      polynom_abs(matrix_constraint_budget)                        cell
%matrix_constraint_card_new_benchmark      bench       matrix_constraint_card_new    cardn(parameter_alpha, matrix_constraint_card_new)           double
%matrix_constraint_card_new_probability    prob        matrix_constraint_card_new    cardn(parameter_alpha, matrix_constraint_card_new)           double
%matrix_constraint_card_new_data           data        matrix_constraint_card_new    cardn(parameter_alpha, matrix_constraint_card_new)           double
%matrix_constraint_card_new_vars           vars        matrix_constraint_card_new    cardn(parameter_alpha, matrix_constraint_card_new)           cell
%point_lowerbounds_data                    data        point_lowerbounds             box: >= point_lowerbounds, <= point_upperbounds              double
%point_lowerbounds_vars                    vars        point_lowerbounds             box: >= point_lowerbounds, <= point_upperbounds              cell
%point_upperbounds_data                    data        point_upperbounds             box: >= point_lowerbounds, <= point_upperbounds              double
%point_upperbounds_vars                    vars        point_upperbounds             box: >= point_lowerbounds, <= point_upperbounds              cell
%parameter_bound_data                      data        parameter_bound               constraint: <= parameter_bound, linearize = 1                double
%parameter_bound_1_data                    data        parameter_bound_1             constraint: <= parameter_bound_1, linearize = 1              double
%parameter_alpha_data                      data        parameter_alpha               cardn(parameter_alpha, matrix_constraint_card_new)           double
%parameter_solver_data                     data        parameter_solver              solver: parameter_solver, precision = parameter_precision    char
%parameter_precision_data                  data        parameter_precision           solver: parameter_solver, precision = parameter_precision    char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = problem_cdohedge_1_subroutine(matrix_scenarios_benchmark,matrix_scenarios_data,matrix_scenarios_vars,matrix_constraint_budget_data,matrix_constraint_budget_vars,matrix_constraint_card_new_benchmark,matrix_constraint_card_new_probability,matrix_constraint_card_new_data,matrix_constraint_card_new_vars,point_lowerbounds_data,point_lowerbounds_vars,point_upperbounds_data,point_upperbounds_vars,parameter_bound_data,parameter_bound_1_data,parameter_alpha_data,parameter_solver_data,parameter_precision_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_scenarios',matrix_scenarios_data,matrix_scenarios_vars,matrix_scenarios_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_constraint_budget',matrix_constraint_budget_data,matrix_constraint_budget_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_constraint_card_new',matrix_constraint_card_new_data,matrix_constraint_card_new_vars,matrix_constraint_card_new_benchmark,matrix_constraint_card_new_probability);
count = count+1;
iargstruc_arr(count) = point_pack('point_lowerbounds',point_lowerbounds_data,point_lowerbounds_vars);
count = count+1;
iargstruc_arr(count) = point_pack('point_upperbounds',point_upperbounds_data,point_upperbounds_vars);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'linearize = 1',...
'  meanabs_err(matrix_scenarios)',...
'constraint: <= parameter_bound, linearize = 1',...
'  polynom_abs(matrix_constraint_budget)',...
'constraint: <= parameter_bound_1, linearize = 1',...
'  cardn(parameter_alpha, matrix_constraint_card_new)',...
'box: >= point_lowerbounds, <= point_upperbounds',...
'solver: parameter_solver, precision = parameter_precision',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_precision',parameter_precision_data);
problem_statement = strrep(problem_statement,'parameter_bound_1',parameter_bound_1_data);
problem_statement = strrep(problem_statement,'parameter_solver',parameter_solver_data);
problem_statement = strrep(problem_statement,'parameter_bound',parameter_bound_data);
problem_statement = strrep(problem_statement,'parameter_alpha',parameter_alpha_data);

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2019.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

